# FIXME fix all ID/name comments to an if with the user preference

# fix all of these lines:
# make a chat name as well as an ID acceptable here
# possibly a func that does it automatically

proc CHAT_INVITE {name loc id sender msg} {
    tac_output "$sender invited you to chat room '$loc' with id '$id'"
    tac_output "Invitation message is '$msg'"
    tac_output "To accept, type /ca $id or c:a $id"
}

proc CHAT_UPDATE_BUDDY {name id inside blist} {
     foreach i $blist {
         if {$inside == "T"} {
# make a user-selectable option whether
# to display IDs or names...
# ID/name
             tac_output "[ts c]** $i has entered $::TAC(rooms,name,$id)."
             lappend ::TAC(rooms,who,$id) $i
         } else {
             tac_output "[ts c]** $i has left $::TAC(rooms,name,$id)."
             set x [lsearch $::TAC(rooms,who,$id) $i]
             set ::TAC(rooms,who,$id) [lreplace $::TAC(rooms,who,$id) $x $x]
         }
     }
}

proc CHAT_JOIN {name id loc} {

# do we need this?
# i don't really know what it does...
    catch {
        set people $::INVITES($loc,people)
        set msg $::INVITES($loc,msg)

        set p ""
        foreach i [split $people "\n" ] {
            set n [normalize $i]
            if {$n != "" } {
                append p $n
                append p " "
            }
        }

        if {$p != ""} {
            toc_chat_invite $name $id $msg $p
        }

        unset ::INVITES($loc,people)
        unset ::INVITES($loc,msg)
    }

    # at this point, the other guy sees us join
    tac_output "You have joined chat room '$loc' with id '$id'."
    lappend ::TAC(rooms,id) $id
    lappend ::TAC(rooms,name) $loc
    set ::TAC(rooms,name,$id) $name
    set ::TAC(rooms,id,$name) $id
}

proc CHAT_LEFT {name id} {
# ID/name
    tac_output "You have left chat room $::TAC(rooms,name,$id) (id '$id')"
    set x [lsearch $::TAC(rooms,id) $id]
    set ::TAC(rooms,id) [lreplace $::TAC(rooms,id) $x $x]
}

proc CHAT_IN {name id source whisper msg} {
    tac_receive_chat $id $source $whisper $msg
}

proc tac_receive_chat {id remote whisper msg} {
    set whisperstr ""
    if { $whisper == "T" } {
        set whisperstr " (whispers) "
    }

    set text [unHTML $msg] 
# ID/name
    tac_output "<$::TAC(rooms,name,$id):$remote>$whisperstr $text"
}

proc tac_cmd_chat_accept {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9]+)$} $line match cmd id]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

# make a chat name as well as an ID acceptable here
    toc_chat_accept $::NSCREENNAME $id
}

proc tac_cmd_chat_invite {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9]+) ([a-zA-Z0-9]+) (.*)$} $line match cmd id user msg} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

# make a chat name as well as an ID acceptable here
    toc_chat_invite $::NSCREENNAME $id "$msg" $user
}

proc tac_cmd_chat_msg {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) +([0-9]+) (.*)$} $line match cmd id msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

# make a chat name as well as an ID acceptable here
    toc_chat_send $::NSCREENNAME $id $msg
    set ::TAC(lastchat) $id
#    tac_chat_wrapper $id $msg
}

proc tac_cmd_chat_evil {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9]+) ([a-zA-Z0-9]+) *$} $line match cmd id name]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

# make a chat name as well as an ID acceptable here
    toc_chat_evil $::NSCREENNAME $id $name
}

proc tac_cmd_chat_who {exp line} {
    if {[string range $exp end end] == "$"} {
        foreach i $::TAC(rooms,id) {
# ID/name
            tac_output "$i"
            foreach j $::TAC(rooms,who,$i) {
                tac_output "  $j"
            }
        }
        return
    }
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9]+) *$} $line match cmd id]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

# this list is maintained by the client, not the server.

    if {$::TAC(rooms,who,$id) == [list]} { return }
# ID/name
    foreach i $::TAC(rooms,who,$id) {
        tac_output $i
    }
}

proc tac_cmd_chat_join {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([a-zA-Z0-9]+)$} $line match cmd room]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    toc_chat_join $::NSCREENNAME 4 $room
}

proc tac_cmd_chat_leave {exp line} {
    if {[string range $exp end end] == "$"} {
        foreach i $::TAC(rooms,id) {
            toc_chat_leave $::NSCREENNAME $i
        }
        return
    }
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9]+)$} $line match cmd id]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

# make a chat name as well as an ID acceptable here

    toc_chat_leave $::NSCREENNAME $id
}

proc tac_cmd_defleave {exp line} {
    if {[regexp -- {^\@[0-9][0-9]?$} $line match cmd]} {
        set line [string range $line 1 end]
    } elseif {[regexp -- {^[0-9][0-9]?\@$} $line match cmd]} {
        set line [string range $cmd 0 [expr [string length $line] - 2]]
    } else {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    tac_output $cmd
    tac_output $line
#    toc_chat_leave $::NSCREENNAME $::TAC(defbud,$line)
    tac_output "FIXME this doesn't work..."
}

proc tac_cmd_chat_whisper {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) ([0-9]+) ([a-zA-Z0-9]+) (.*)$} $line match cmd id user msg} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

# make a chat name as well as an ID acceptable here
    toc_chat_whisper $::NSCREENNAME $id $user $msg
    set ::TAC(lastchat) $id
    log_chat_whisper $id $user $msg
}

proc tac_cmd_chat_list {exp line} {
# ID/name
    foreach i $::TAC(rooms,id) {
        tac_output $i
    }
}

toc_register_func * CHAT_INVITE       CHAT_INVITE
toc_register_func * CHAT_JOIN         CHAT_JOIN
toc_register_func * CHAT_LEFT         CHAT_LEFT
toc_register_func * CHAT_UPDATE_BUDDY CHAT_UPDATE_BUDDY
toc_register_func * CHAT_IN           CHAT_IN

tac_register_cmd 1 "c" "^/ca "      tac_cmd_chat_accept    "  /ca id           accept chat id"
tac_register_cmd 1 "c" "^/cm "      tac_cmd_chat_msg       "  /cm id msg       send msg to chat id"
tac_register_cmd 1 "c" "^/ce "      tac_cmd_chat_evil      "  /ce id user      warn a user in a chat room"
tac_register_cmd 1 "c" "^/cw "      tac_cmd_chat_who       "  /cw id           show users in a chat room"
tac_register_cmd 1 "c" "^/cw$"      tac_cmd_chat_who
tac_register_cmd 1 "c" "^/cj "      tac_cmd_chat_join      "  /cj name         join chat room 'name'"
tac_register_cmd 1 "c" "^/cs "      tac_cmd_chat_whisper   "  /cs id user msg  whisper to user in chat room"
tac_register_cmd 1 "c" "^/ci "      tac_cmd_chat_invite    "  /ci id user msg  invite user to a chat room"
tac_register_cmd 1 "c" "^/cl "      tac_cmd_chat_leave     "  /cl {id}         leave chat room 'id' or all rooms"
tac_register_cmd 1 "c" "^/cl$"      tac_cmd_chat_leave
tac_register_cmd 1 "c" "^/cr$"      tac_cmd_chat_list      "  /cr              list chat rooms you are in"

tac_register_cmd 2 "c" "^c:a "      tac_cmd_chat_accept    "  c:a id           accept chat id"
tac_register_cmd 2 "c" "^c:m "      tac_cmd_chat_msg       "  c:m id msg       send msg to chat id"
tac_register_cmd 2 "c" "^c:e "      tac_cmd_chat_evil      "  c:e id user      warn a user in a chat room"
tac_register_cmd 2 "c" "^c:w "      tac_cmd_chat_who       "  c:w {id}         show users in a chat room"
tac_register_cmd 2 "c" "^c:w$"      tac_cmd_chat_who
tac_register_cmd 2 "c" "^c:j "      tac_cmd_chat_join      "  c:j name         join chat room 'name'"
tac_register_cmd 2 "c" "^c:s "      tac_cmd_chat_whisper   "  c:s id user msg  whisper to user in chat room"
tac_register_cmd 2 "c" "^c:i "      tac_cmd_chat_invite    "  c:i id user msg  invite user to a chat room"
tac_register_cmd 2 "c" "^c:l "      tac_cmd_chat_leave     "  c:l {id}         leave chat room 'id' or all rooms"
tac_register_cmd 2 "c" "^c:l$"      tac_cmd_chat_leave
tac_register_cmd 2 "c" "^c:h$"      tac_cmd_help
tac_register_cmd 2 "c" "^c:r$"      tac_cmd_chat_list      "  c:r              list chat rooms you are in"

set TAC(lastchat) ""
set TAC(rooms,id) [list]
set TAC(rooms,name) [list]
set TAC(nameid) 1         ;# this means name
