# make an autobud-like feature

proc tac_cmd_lschat {exp line} {
    tac_output "Defined Chats"
    tac_output "---------------"
    tac_output "Last Chat: $::TAC(lastchat)"
    foreach j [list 0 1 2 3 4 5 6 7 8 9] {
        if { $::TAC(defchat,$j) != "" } {
            tac_output "Preset $j: $::TAC(defchat,$j)"
        }
    }
    foreach j [list 0 1 2 3 4 5 6 7 8 9] {
        foreach k [list 0 1 2 3 4 5 6 7 8 9] {
            if { $::TAC(defchat,$j$k) != "" } {
                tac_output "Preset $j$k: $::TAC(defchat,$j$k)"
            }
        }
    }
}

proc tac_cmd_rmchat {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (c?[0-9][0-9]?) *$} $line match cmd num]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if { $::TAC(defbud,$num) == "" } {
        tac_output "Preset $num not defined."
    } else {
        tac_output "$::TAC(defchat,$num) (preset \#$num) removed from list."
        set ::TAC(defchat,$num) ""
    }
}

proc tac_cmd_mvchat {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (c?[0-9][0-9]?) (c?[0-9][0-9]?) *$} $line match cmd num1 num2]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set tmp $::TAC(defchat,$num2)
    set ::TAC(defchat,$num2) $::TAC(defchat,$num1)
    set ::TAC(defchat,$num1) $tmp
    if { "$::TAC(defchat,$num1)"=="" } then {
        tac_output "Preset \#$num1 is undefined."
    } else {
        tac_output "Preset \#$num1 is now $::TAC(defchat,$num1)"
    }
    if { "$::TAC(defchat,$num2)"=="" } then {
        tac_output "Preset \#$num2 is undefined."
    } else {
        tac_output "Preset \#$num2 is now $::TAC(defchat,$num2)"
    }
}

proc tac_cmd_scdefault {exp line} {
    if {![regexp -- {^([a-zA-Z0-9/:]+) (c?[0-9][0-9]?) +([a-zA-Z0-9]+) *$} $line match cmd num name]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set ::TAC(defchat,$num) $name
    tac_output "Preset \#$num is now $::TAC(defchat,$num)."
}

proc tac_cmd_scdef2 {exp line} {
    set line [string trim $line]
    if {![regexp -- {^(c[0-9][0-9]?=[a-zA-Z0-9]+)$} $line match arg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set num [string range $arg 0 2]
    if {[string range $num 2 2] == "=" } { set num [string range $num 0 1] }
    set name [string range $arg [expr [string length $num] + 1] end]
    if {$name == "@" || $name == "#" } {
        set ::TAC(defchat,$num) ""
        tac_output "$::TAC(defchat,$num) (preset \#$num) removed from list."
    } else {
        set ::TAC(defchat,$num) $name
        tac_output "Preset \#$num is now $::TAC(defchat,$num)."
    }
}
    
proc tac_cmd_cdefault {exp line} {
    if {![regexp -- {^(c[0-9][0-9]?) (.*)$} $line match cmd msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {"$::TAC(defchat,$cmd)"==""} { 
        tac_output "Preset $cmd not defined"
        return 
    }

    toc_chat_send $::NSCREENNAME $::TAC(defchat,$cmd) $msg
    set ::TAC(lastchat) $::TAC(defchat,$cmd)
    tac_chat_wrapper $::TAC(defchat,$cmd) $msg
}

tac_register_cmd 0 "d" "^c\[0\-9\]\[0\-9\]\? "   tac_cmd_cdefault "  c<num> message   send message to chat num"
tac_register_cmd 0 "d" "^\[0\-9\]\[0\-9\]\?@$"   tac_cmd_defleave "  @<num>           leave chat num"
tac_register_cmd 0 "d" "^@\[0\-9\]\[0\-9\]\?$"   tac_cmd_defleave "  c<num>=@         remove chat preset num"
tac_register_cmd 0 "d" "^c\[0\-9\]\[0\-9\]\?\="  tac_cmd_scdef2   "  c<num>=chat      set chat preset num"

# an attemt to accept all combinations of spaces around the '='.
# the [string trim...]  at the top of the proc tac_cmd_sdef2 should
# take them out for us, simplifying the entire process.
# no, it doesn't exactly work though
#tac_register_cmd 0 "d" "^c\[0\-9\]\[0\-9\]\?\= "  tac_cmd_scdef2
#tac_register_cmd 0 "d" "^c\[0\-9\]\[0\-9\]\? \="  tac_cmd_scdef2
#tac_register_cmd 0 "d" "^c\[0\-9\]\[0\-9\]\? \= " tac_cmd_scdef2

tac_register_cmd 1 "d" "^/ds "     tac_cmd_scdefault      "  /ds num chat     set chat preset num"
tac_register_cmd 1 "d" "^/dl$"     tac_cmd_lschat         "  /dc              list previously defined chat presets"
tac_register_cmd 1 "d" "^/dr "     tac_cmd_rmchat         "  /dr num          remove chat num"
tac_register_cmd 1 "d" "^/dm "     tac_cmd_mvbuddy        "  /dm num1 num2    move chat preset num1 to slot num2"

tac_register_cmd 2 "d" "^d:s "      tac_cmd_scdefault     "  d:s num user/id  set chat preset num"
tac_register_cmd 2 "d" "^d:l$"      tac_cmd_lschat        "  d:l              list previously defined chat presets"
tac_register_cmd 2 "d" "^d:r "      tac_cmd_rmchat        "  d:r num          remove chat num"
tac_register_cmd 2 "d" "^d:m "      tac_cmd_mvchat        "  d:m num1 num2    move chat preset num1 to slot num2"
tac_register_cmd 2 "d" "^d:h$"      tac_cmd_help

foreach j [list 0 1 2 3 4 5 6 7 8 9] {
    foreach k [list 0 1 2 3 4 5 6 7 8 9] {
        set TAC(defchat,$j$k) ""
    }
    set TAC(defchat,$j) ""
}
